<?php
$BACK_PATH = '../../../../typo3/';
define('TYPO3_MOD_PATH', '../typo3conf/ext/ods_osm/wizard/');
$MCONF['name']='xMOD_tx_odsosm_wizard';
$MCONF['access']='user,group';
$MCONF['script']='index.php';

require_once ($BACK_PATH.'init.php');
require_once ($BACK_PATH.'template.php');
$LANG->includeLLFile('EXT:ods_osm/wizard/locallang.xml');

require_once(PATH_t3lib."class.t3lib_scbase.php");
require_once(t3lib_extMgm::extPath('ods_osm').'class.tx_odsosm_div.php');

class tx_odsosm_wizard extends t3lib_SCbase {
	// Internal, static: GPvars
	var $P; // Wizard parameters, coming from TCEforms linking to the wizard.
	var $config;

	/**
	* Main function of the module. Write the content to $this->content
	*
	* @return   the wizard
	*/
	function main(){
		global $BE_USER,$BACK_PATH;

		// Draw the header.
		$this->doc = t3lib_div::makeInstance('mediumDoc');
		$this->doc->backPath = $BACK_PATH;

		// GPvars:
		$this->P=t3lib_div::_GP('P');
			
		$this->pageinfo = t3lib_BEfunc::readPageAccess($this->id,$this->perms_clause);
		$access = is_array($this->pageinfo) ? 1 : 0;
		if (($this->id && $access) || ($BE_USER->user['admin'] && !$this->id) || ($BE_USER->user["uid"] && !$this->id))    {
			if (($BE_USER->user['admin'] && !$this->id) || ($BE_USER->user["uid"] && !$this->id)) {
				$this->moduleContent();
			}
		}
	}

	/**
	* Outputting the accumulated content to screen
	*
	* @return	void
	*/
	function printContent(){
		echo $this->doc->startPage($GLOBALS['LANG']->getLL('title'));
		echo $this->content;
		echo $this->doc->endPage();
	}

  function moduleContent(){
		global $LANG;

		$this->config=unserialize($GLOBALS['TYPO3_CONF_VARS']['EXT']['extConf']['ods_osm']);
		$this->config['id']='map';
		$this->config['layer']=1;
		$this->config['mouse_navigation']=true;
		$this->config['show_pan_zoom']=1;
		$this->config['zoom']=15;

		$res=$GLOBALS['TYPO3_DB']->exec_SELECTquery('tx_odsosm_lat,tx_odsosm_lon',$this->P['table'],'uid='.intval($this->P['uid']));
		$row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($res);
		if(floatval($row['tx_odsosm_lon'])==0){
			$row['tx_odsosm_lon']=0;
			$row['tx_odsosm_lat']=45;
			$this->config['zoom']=1;
		}

		tx_odsosm_div::getMapCore($GLOBALS['BACK_PATH'].'../');

		$layers=$GLOBALS['TYPO3_DB']->exec_SELECTgetRows('uid,title,javascript,javascript_include','tx_odsosm_layer','uid IN ('.$this->config['layer'].')');
		$jsMainLayer=tx_odsosm_div::getMainLayers($layers,$GLOBALS['BACK_PATH'].'../');

		$this->doc->JScode.="
<script type=\"text/javascript\">
	var map; //complex object of type OpenLayers.Map

	OpenLayers.Control.Click = OpenLayers.Class(OpenLayers.Control, {                
		defaultHandlerOptions: {
			'single': true,
			'double': false,
			'pixelTolerance': 0,
			'stopSingle': false,
			'stopDouble': false
		},
		initialize: function(options) {
			this.handlerOptions = OpenLayers.Util.extend(
				{}, this.defaultHandlerOptions
			);
			OpenLayers.Control.prototype.initialize.apply(
				this, arguments
			); 
			this.handler = new OpenLayers.Handler.Click(
				this, {
					'click': this.onClick
				}, this.handlerOptions
			);
		}, 
		onClick: function(evt) {
			var pixel = new OpenLayers.Pixel(evt.xy.x,evt.xy.y);
			var lonlat = map.getLonLatFromPixel(pixel);
			var lonlatGCS = OpenLayers.Layer.SphericalMercator.inverseMercator(lonlat.lon, lonlat.lat);
			window.opener.document.editform['".strtr($this->P['itemName'],array('_hr'=>''))."'].value=lonlatGCS.lon;
			window.opener.document.editform['".$this->P['itemName']."'].value=lonlatGCS.lon;
			window.opener.".$this->P['fieldChangeFunc']['TBE_EDITOR_fieldChanged']."
			window.opener.document.editform['".strtr($this->P['itemName'],array('_hr'=>'','lon'=>'lat'))."'].value=lonlatGCS.lat;
			window.opener.document.editform['".strtr($this->P['itemName'],array('lon'=>'lat'))."'].value=lonlatGCS.lat;
			window.opener.".strtr($this->P['fieldChangeFunc']['TBE_EDITOR_fieldChanged'],array('lon'=>'lat'))."
			window.opener.focus();
			close();
		}
	});

	function map(){
		".tx_odsosm_div::getMapMain()."
		".$jsMainLayer."
		mapCenter(map,".$row['tx_odsosm_lat'].",".$row['tx_odsosm_lon'].",".$this->config['zoom'].");

		var control = new OpenLayers.Control.Click({
			handlerOptions: {
				'single': true
			}
		});
		map.addControl(control);
		control.activate();
	}
</script>
";

		$this->content.='<div style="position:absolute;width:100%;height:100%;" id="map"></div><script type="text/javascript">map();</script>';
	}
}

if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/ods_osm/wizard/index.php'])    {
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/ods_osm/wizard/index.php']);
}

// Make instance:
$SOBE = t3lib_div::makeInstance('tx_odsosm_wizard');
$SOBE->init();
$SOBE->main();
$SOBE->printContent();
?>
